// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// ignore_for_file: unused_element

// AUTO GENERATED FILE, DO NOT EDIT.
//
// Generated by `package:ffigen`.
import 'dart:ffi' as ffi;

/// Bindings to src/webcrypto_dart_dl.h.
class WebCryptoDartDL {
  /// Holds the symbol lookup function.
  final ffi.Pointer<T> Function<T extends ffi.NativeType>(String symbolName)
      _lookup;

  /// The symbols are looked up in [dynamicLibrary].
  WebCryptoDartDL(ffi.DynamicLibrary dynamicLibrary)
      : _lookup = dynamicLibrary.lookup;

  /// The symbols are looked up with [lookup].
  WebCryptoDartDL.fromLookup(
      ffi.Pointer<T> Function<T extends ffi.NativeType>(String symbolName)
          lookup)
      : _lookup = lookup;

  /// Attach a finalizer for pointer to object, such that `finalizer(pointer)` will
  /// be called when `object` is collected by the Dart garbage collector.
  ///
  /// The external_allocation_size is used by the Dart garbage collector as a hint
  /// about the size of the external allocation.
  ///
  /// Returns 1 on success.
  int webcrypto_dart_dl_attach_finalizer(
    Object object,
    ffi.Pointer<ffi.Void> pointer,
    ffi.Pointer<ffi.NativeFunction<webcrypto_finalizer_t>> finalizer,
    int external_allocation_size,
  ) {
    return _webcrypto_dart_dl_attach_finalizer(
      object,
      pointer,
      finalizer,
      external_allocation_size,
    );
  }

  late final _webcrypto_dart_dl_attach_finalizer_ptr =
      _lookup<ffi.NativeFunction<_c_webcrypto_dart_dl_attach_finalizer>>(
          'webcrypto_dart_dl_attach_finalizer');
  late final _dart_webcrypto_dart_dl_attach_finalizer
      _webcrypto_dart_dl_attach_finalizer =
      _webcrypto_dart_dl_attach_finalizer_ptr
          .asFunction<_dart_webcrypto_dart_dl_attach_finalizer>();

  /// Initialize Dart API with dynamic linking.
  ///
  /// Must be called with `NativeApi.initializeApiDLData` from `dart:ffi`, before
  /// using other functions.
  ///
  /// Returns 1 on success.
  int webcrypto_dart_dl_initialize(
    ffi.Pointer<ffi.Void> initialize_api_dl_data,
  ) {
    return _webcrypto_dart_dl_initialize(
      initialize_api_dl_data,
    );
  }

  late final _webcrypto_dart_dl_initialize_ptr =
      _lookup<ffi.NativeFunction<_c_webcrypto_dart_dl_initialize>>(
          'webcrypto_dart_dl_initialize');
  late final _dart_webcrypto_dart_dl_initialize _webcrypto_dart_dl_initialize =
      _webcrypto_dart_dl_initialize_ptr
          .asFunction<_dart_webcrypto_dart_dl_initialize>();

  /// Function to lookup BoringSSL symbols based on index in the Sym enum.
  /// See src/symbols.yaml for details.
  ffi.Pointer<ffi.Void> webcrypto_lookup_symbol(
    int index,
  ) {
    return _webcrypto_lookup_symbol(
      index,
    );
  }

  late final _webcrypto_lookup_symbol_ptr =
      _lookup<ffi.NativeFunction<_c_webcrypto_lookup_symbol>>(
          'webcrypto_lookup_symbol');
  late final _dart_webcrypto_lookup_symbol _webcrypto_lookup_symbol =
      _webcrypto_lookup_symbol_ptr.asFunction<_dart_webcrypto_lookup_symbol>();
}

class _Dart_Handle extends ffi.Opaque {}

typedef webcrypto_finalizer_t = ffi.Void Function(
  ffi.Pointer<ffi.Void>,
);

typedef _c_webcrypto_dart_dl_attach_finalizer = ffi.Int32 Function(
  ffi.Handle object,
  ffi.Pointer<ffi.Void> pointer,
  ffi.Pointer<ffi.NativeFunction<webcrypto_finalizer_t>> finalizer,
  ffi.IntPtr external_allocation_size,
);

typedef _dart_webcrypto_dart_dl_attach_finalizer = int Function(
  Object object,
  ffi.Pointer<ffi.Void> pointer,
  ffi.Pointer<ffi.NativeFunction<webcrypto_finalizer_t>> finalizer,
  int external_allocation_size,
);

typedef _c_webcrypto_dart_dl_initialize = ffi.Int32 Function(
  ffi.Pointer<ffi.Void> initialize_api_dl_data,
);

typedef _dart_webcrypto_dart_dl_initialize = int Function(
  ffi.Pointer<ffi.Void> initialize_api_dl_data,
);

typedef _c_webcrypto_lookup_symbol = ffi.Pointer<ffi.Void> Function(
  ffi.Int32 index,
);

typedef _dart_webcrypto_lookup_symbol = ffi.Pointer<ffi.Void> Function(
  int index,
);
